//+------------------------------------------------------------------+
//|                                                   LoongMAx96.mq5 |
//|                             Copyright 2010, Loong@forum.mql4.com |
//|                                             Loong@forum.mql4.com |
//+------------------------------------------------------------------+
#property copyright "2010, Loong@forum.mql4.com"
#property link      "Loong@forum.mql4.com"
#property version   "1.00"
#include "CMyBuffer.mqh"   //in current fold
#include "fColorInc.mqh"   //in current fold
#define iNum 96

#property indicator_chart_window
#property indicator_buffers iNum
#property indicator_plots   iNum
//---- plot MA
#property indicator_type1   DRAW_LINE
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

/*
Some time ago (at least before 2009.11.07), I can use a function to set plot line color, such as  
	PlotIndexSetInteger(i,PLOT_LINE_COLOR,iColor);
without explicit declare statement, such as
	#property indicator_color1  Red
But now(2010.01.11), I must write many "#property" in my multi-line indicator, 
otherwise my indicator will draw all line with a default color (Silver?).
I like the old characteristic (set color without explicit declare property).
I hope to resume it.
This indicator is only 211 lines (include empty and comment line), 
but 96 lines is occupied by indicator_color!
----------------------------------------------------------------------------
Add by Loong 20100112
http://www.mql5.com/en/forum/331
Thank 'Rosh' and 'investeo'!
   MAA[i].mPlotIndexSetInteger(i,PLOT_COLOR_INDEXES,1);
can substitute for
   #property indicator_color
and mPlotIndexSetInteger() can put in a loop.
*/

//--- input parameters
input bool               AsSeries=true;
input ENUM_MA_METHOD     smootMode=MODE_EMA;
input ENUM_APPLIED_PRICE price=PRICE_CLOSE;
input int                shift=0;
//---- indicator parameters
int iParam[iNum];
//--- indicator buffers
CMyBuffer MAA[iNum];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
bool SequenceQuadratic(int& iReturnValue[], const int iSize, const int i0, const int im)
{
   if(ArraySize(iReturnValue)<2)   return false;
   if(iSize<2)   return false;
   iReturnValue[0]=2;
   for(int i=1;i<iSize;i++) iReturnValue[i]=(i+1)*(i+1);
   return true;
}
int OnInit()
  {

   IndicatorSetString(INDICATOR_SHORTNAME,"LoongMAx96");//+IntegerToString(AsSeries)
//--- indicator buffers mapping
   color iColor = Red;
   bool bReturn = SequenceQuadratic(iParam,iNum,2,2);  
   int iTmp;               //temporary variable for bug of MT5
   for(int i=0; i<iNum; i++)
   {
      MAA[i].Init();
      iTmp=iParam[i];      //You CANNOT assign a array member with a member of another array, 
      MAA[i].mParam=iTmp;  //so you need a temporary variable.
      iColor = ColorInc96(i);
      MAA[i].mSetIndexBuffer(i,INDICATOR_DATA);
      MAA[i].mPlotIndexSetInteger(i,PLOT_DRAW_TYPE,DRAW_LINE);
      MAA[i].mPlotIndexSetInteger(i,PLOT_LINE_STYLE,STYLE_SOLID);
      MAA[i].mPlotIndexSetInteger(i,PLOT_COLOR_INDEXES,1); //Add by Loong 20100112
      MAA[i].mPlotIndexSetInteger(i,PLOT_LINE_COLOR,iColor);
      MAA[i].mPlotIndexSetString(i,PLOT_LABEL,"MA"+IntegerToString(i,2,'0')+"(color:"+IntegerToString(iColor)+")");//Print(IntegerToString())
      MAA[i].mhandle=iMA(NULL,0,MAA[i].mParam,shift,smootMode,price); //Symbol()
   }
/*
   if(AsSeries) {
      for(int i=0; i<iNum; i++)
      {
         MAA[i].mArraySetAsSeries(true);
      }
   }
*/
   return(0);
  }
void OnDeinit(const int reason)
{
      for(int i=0; i<iNum; i++)
      {
         MAA[i].Deinit();
      }
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//--- Copy the values of the moving average in the buffer MABuffer
   int copied;
   int ibars;
   for(int i=0; i<iNum; i++)
   {
      copied=MAA[i].mCopyBuffer(rates_total);
   }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+